﻿
init python:
    class nvl_phone_class:
        def __init__(self):
            self.elapsed = 0
            self.typing = False
            self.times = []
            self.locked = False
            self.name = None
            self.person = None
        def tick(self):
            pass
            self.elapsed += 1
            if len(self.times):
                
                if self.elapsed >= self.times[0]:
                    self.elapsed = 0
                    if self.typing:
                        self.typing = False
                    else:
                        self.typing = True
                    self.times.pop(0)
            else:
                self.typing = False
                self.locked = False
                return 1
        def type(self, person, times = [10, 10, 10, 10]):
            self.person = person
            self.times = times
            self.elapsed = 0
            self.typing = True
            self.locked = True
            renpy.pause(hard = True)
        def abort_typing(self):
            self.times = []
            self.elapsed = 0
            self.typing = False
            self.locked = False
            return 1

default nvl_phone = nvl_phone_class()

screen nvl(dialogue, items=None):
    style_prefix "nvlphone"
    add "#0008"
    frame:
        xysize(600,900) padding(0,0) background "#222" align .5,.5

        frame: # Top bar
            ysize 100 xfill True background "#111" yalign 0.0
            button:
                align 0.0,.5 background "#222" xysize 40,40
                text "⬅"
                action Hide("chat_app_chat")
            text nvl_phone.name
        viewport:
            draggable True scrollbars None yinitial 1.0 align .5,1.0
            xfill False
            yfill False
            yalign 1.0
            ymaximum 690 yoffset -100
            vbox: # Chat
                xsize 560 yalign 1.0
                spacing 10
                for n, d in enumerate(dialogue):

                    if d.who == "Ayame":
                        hbox:
                            xalign 1.0
                            frame:
                                background Frame(im.Flip("phone/chat_frame.png", True), 8, 8, 16, 8)
                                padding 8,8,16,8 xmaximum 420 yminimum 64
                                text d.what:
                                    color "#000"

                            if not dialogue[n-1].who == d.who or n == 0:
                                add "phone {}".format(d.who)
                            else:
                                null width 64
                    elif d.who == None:
                        frame:
                            background None padding 20,20 xalign .5
                            text d.what:
                                color "#fff" size 16
                    elif d.who == "NVLIMAGE":
                        button:
                            xalign .5 padding 10,10 background "#555"
                            add d.what at fit_zoom(image_fit(d.what, [300,2000]))
                            action Show("nvl_phone_image", img = d.what)
                    else:
                        hbox:
                            xalign 0.0
                            if not dialogue[n-1].who == d.who or n == 0:
                                add "phone {}".format(d.who)
                            else:
                                null width 64
                            frame:
                                background Frame("phone/chat_frame.png", 16, 8, 8, 8)
                                padding 16,8,8,8 xmaximum 420 yminimum 64
                                text d.what:
                                    color "#000"
        text d.what: # Ignore
            id d.what_id
            yoffset -1000

        vbox: # Input
            yalign 1.0 spacing -8
            if nvl_phone.typing:
                hbox:
                    xalign 0.0 xoffset 12
                    text str(nvl_phone.person) size 15
                    text "is typing..." size 15

            frame:
                background "#111" margin 10,10
                padding 8,8,16,8 xfill True yminimum 90
                text "Type something..." color "#aaa" xalign 0.0


        frame: # Choice
            align .5,.5 background "#222" padding 0,0
            vbox:
                spacing 4
                for i in items:
                    button:
                        text i.caption
                        action i.action
                        background "#111" yminimum 64 xsize 540 padding 10,10
    if nvl_phone.locked:
        
        # button: # While typing this button will keep the screen locked, comment out if you don't want it to be locked
        #     background None
        #     action NullAction()
        timer .1 repeat True action Function(nvl_phone.tick)

screen nvl_phone_image(img):
    modal True
    button:
        align .5,.5
        xysize 600,900 background "#444"
        action Hide("nvl_phone_image")
        add img at fit_zoom(image_fit(img, [580,880])) align .5,.5

style nvlphone_text:
    size 20
    align (.5,.5)


style nvlphone:
    align (.5,.5)

define config.nvl_list_length = 40 # The number of lines you can scroll back to see
# define config.nvl_adv_transition = None
# define config.adv_nvl_transition = None
define aya = Character("Ayame", kind=nvl)
define rin = Character("Ririn", kind=nvl)
define may = Character("Mayo", kind=nvl)
define nvl_sys = Character(None, kind=nvl)
define nvl_img = Character("NVLIMAGE", kind=nvl)
image phone Ayame = "phone/img2.png"
image phone Ririn = "phone/img1.png"
image phone Mayo = "phone/mayo.png"

label nvl_phone_example:

    $ preferences.transitions = 0 #disable transitions when entering nvl mode
    # it's not an elegant solution but we have to use this one till I find a better way
    # don't forget to set it back to 2 before exiting this mode

    $ nvl_phone.name = "Ririn"

    rin "hey{nw}" # {nw} will automatically advance the conversation
    $ nvl_phone.type("Ririn") # who is typing
    # pause
    rin "what are you wearing?{nw}"
    $ nvl_phone.type("Ririn", [10, 20, 35]) # You can give it a list of typing pauses in tenth of seconds in this case it shows [typing for 1 sec, nothing foe 2 sec, typing for 3.5 sec]
    # pause
    rin "something naughty I hope :3"
    # if you don't add a `typing...` the game advances with user input instead and {nw} is not necessary 
    rin "or nothing at all{nw}"

    $ nvl_phone.abort_typing() # Put this before every menu to avoid errors in case the player skipped through the messages
    # You can use either normal or nvl menus
    menu (nvl=True): # You can have normal dialogue but letting the player click each one gives the illusion of replying
        "stop it":
            aya "stop it{nw}"
    menu (nvl=True):
        ":(":
            aya ":({nw}"
    rin "alright, alright"
    rin "just kidding"
    $ renpy.block_rollback() # This stops the rollback when the player rolls back to the line after this
    rin "are you ready for tomorrow? hiking, camping, marshmallows"
    rin "and boys :3"
    menu (nvl=True):
        "I'm not sure...":
            aya "I'm not sure...{nw}"
    menu (nvl=True):
        "Boys can be rowdy and loud on trips like this.":
            aya "Boys can be rowdy and loud on trips like this.{nw}"
    rin "that's not an answer I can accept.."
    rin "do you want me to come over and tackle you to submission again?"
    
    menu (nvl=True):
        "no, I'll get ready":
            aya "no, I'll get ready{nw}"
        "I'll call you":
            aya "I'll call you{nw}"
            rin "Wearing my shoes."
            menu (nvl=True):
                "Alright, alright, fine, I'll come.":
                    aya "Alright, alright, fine, I'll come.{nw}"
        "I said no":
            aya "I said no.{nw}"
            rin "Don't tell me..."
            rin "Have you found a BF?"
            aya "Noooooooooooo!"
            rin "Do you want one?"
            aya "..."
            rin "Your coming or I'm giving your number to Kenji."
            aya "You're terrible..."
            rin "Thats a yes, kind of... Rin wins again."
    rin "ok see you tomorrow!"
    rin "bye"
    menu (nvl=True):
        "bye":
            aya "bye"

    $ nvl_phone.name = "You, Ririn and Mayo" # Change the conversation's name
    nvl_sys "Mayo joined this conversation.{nw}" # A system message.
    $ nvl_phone.type("Mayo", [10, 20, 10]) # the name changes when somebody else us typing
    # pause
    may "Am I late?"
    rin "Yes. We're leaving without you."
    may "Rin chan you're mean!!!!"
    aya "Don't listen to her, there's no such agreement."
    may "I'm terribly sorry."
    may "A scarry cat was blocking our door."
    may "I had to wait for him to leave."
    may "Let me send his picture."
    nvl_img "phone/IMG-1023.jpg"
    rin "You're lucky he he didn't eat you {image=phone/smiley_1.png}"
    $ preferences.transitions = 2 
    pause







